﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Documents.Excel;
using System.Diagnostics;

namespace Summary
{
    public partial class Form1 : Form
    {
        private DataTable table = null;

        public Form1()
        {
            this.InitializeComponent();
            this.grid.InitializeLayout += new InitializeLayoutEventHandler(grid_InitializeLayout);
            this.grid.DataSource = this.Table;
        }

        void grid_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            UltraGridColumn col = this.grid.DisplayLayout.Bands[0].Columns["Number"];
            col.Format = "#,###.00";
            col.CellAppearance.TextHAlign = HAlign.Right;
        }

        private DataTable Table
        {
            get
            {
                if ( this.table == null )
                {
                    this.table = new DataTable();
                    this.table.Columns.Add( "Name", typeof(string) );
                    this.table.Columns.Add( "Number", typeof(decimal) );

                    Random r = new Random();

                    for ( int i = 0; i < 10; i ++ )
                    {
                        double seed = r.NextDouble();    
                        decimal value = (decimal)(10000D * seed);
                        this.table.Rows.Add( new object[]{i.ToString(), value} );
                    }
                }

                return this.table;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Workbook wb = new Workbook();
            Worksheet ws = wb.Worksheets.Add("sheet1");

            for ( int i = 0; i < this.grid.Rows.Count; i ++ )
            {
                UltraGridRow row = this.grid.Rows[i];
                ws.Rows[i].Cells[0].Value = row.Cells[0].Value;

                //  Format the cell value.
                string s = ValueConstraint.ValueToDataValue(
                    row.Cells[1].Value,
                    typeof(string),
                    null,
                    row.Cells[1].Column.Format)
                    as string;

                ws.Rows[i].Cells[1].Value = s;
            }

            wb.Save("temp.xls");
            Process.Start("temp.xls");

        }

    }
}
